<!--

// these functions will create a sortable table 

// to make a sortable table you must:
// 1) make a data array for each of the columns in the table that contains the data
// 2) keep the cycle numbers also in an array
// 3) make an array which contains 1 entry for each column keeping the state of the last sort Ascending (=0) or Descending(=1);
// 3) make 1 sortArray - it is an Array of the following arrays - you just have to create them - the sort functions will fill them
//   -[0] an array which will contain the cycle indexes
//   -[1] an array which will contain the data to be sorted
//   -[2] an index array - used internally by the sort

// 4) now Call "StartSortTable" - the hRef array contains the callback functions which call the sort
// 5) now Call "AddLineToSortTable" for each line in the table
// 6) then Call "EndSortTable" when all the lines are filled

// 7) in the callback Call "DoSortColumn"  - give it the sortArray, true or false to sort Ascending, the data for the column you
//     want sorted, the cycle array, then the compare function(compareNumbers or compareStrings) and whether 
//     or not you want the view to be refreshed.

cycleIndex =0;
dataIndex = 1;
indexIndex =2;

// now the sort stuff
function compareNumbers(a, b) 
{
	return( a <= b? true: false);
	
}

function compareStrings(a, b) 
{	
	
	return( a.toLowerCase() <= b.toLowerCase()? true: false);
	
}

function 	my_sort(sortArray, compareFunction)
{

	sortDataArray = sortArray[dataIndex];
	sortCycleArray = sortArray[cycleIndex];
	
	//here we sort the data - but keep track of the cycle number - put that in the sorted list
	var tmpData = new Array();
	
	// Bernhard, Du hast bestimmt ein besseres sort - dieses habe ich aus dem Bible
	
	var gap;
	var i;
	var j;
	var temp;
	var tempCycle;
	
	for (gap = parseInt(sortDataArray.length/2, 10);  parseInt(gap, 10) > 0 ; gap = parseInt(gap/2, 10))
	{

		for (i= gap; i < sortDataArray.length; i++)
		{
			for (j = i-gap; j >=0; j-= gap)
			{
				status = compareFunction(sortDataArray[j],  sortDataArray[j+gap]);
				if (status == "true")
				{
					break;
				}
						
				temp = sortDataArray[j];
				tempCycle = sortCycleArray[j];
				
				sortDataArray[j] = sortDataArray[j+gap];
				sortCycleArray[j] = sortCycleArray[j+gap];
				
				sortDataArray[j + gap] = temp;
				sortCycleArray[j + gap] = tempCycle;
			}
		}
	}
	return;
	
}


function FillSortTable(sortArrayArray, dataArray, cycleArray)
{
	sortDataArray = sortArrayArray[dataIndex];
	sortCycleArray = sortArrayArray[cycleIndex]
    for (fi = 0; fi < dataArray.length; fi++)
    {
        sortDataArray[fi] = dataArray[fi];
		sortCycleArray[fi] = cycleArray[fi];
    }
	return;
}


function SortTableAndRefresh( SortArrayArray, dataCycleArray,  doRefresh)
{
	sortCycleArray = SortArrayArray[cycleIndex];
	sortIndexArray = SortArrayArray[indexIndex];

		// here we go t
        si = 0;
        for (i = 0; i < dataCycleArray.length; i++)
        {
			for (j = 0; j < dataCycleArray.length; j++)
            {
				if (sortCycleArray[i] ==  dataCycleArray[j] )
                {
                       
                     sortIndexArray[si] = j;
                      si++;
                       break;
                 }
             }
        }
		
		if (doRefresh == true)
		{
			if (navigator.appVersion.charAt(0) == '3')
			{
      			RefreshPage(false); //try to scroll
			}
			else {
				RefreshPage(true); //try to scroll
			}
		}
	return;
}

function StartSortTable(documentToWrite, label, headerColor, columnHeaderArray, columnWidthArray, columnHREFArray)
 {
 	if (label != "")
	{
	 	documentToWrite.writeln("<TR><TD HEIGHT='8'>&nbsp;</TD></TR>");
	 	documentToWrite.writeln("<TR><TD>");
		 	documentToWrite.write("<FONT SIZE='-1'><I>");
			documentToWrite.write(label);
			documentToWrite.write("</i></FONT>\n");
		documentToWrite.writeln("</TD></TR>");
	}

 	documentToWrite.writeln("<TR><TD>");

		documentToWrite.write("<TABLE BORDER=1 COLS=");
		documentToWrite.write(columnHeaderArray.length);
		documentToWrite.write(" WIDTH='100%' align='CENTER' cellpadding=2  cellspacing=0>\n");
		
		documentToWrite.writeln("<TR>");
		for (i = 0; i < columnHeaderArray.length; i++)
		{
			 documentToWrite.write("<TH bgcolor='");
			 documentToWrite.write(headerColor);
			 documentToWrite.write("' ");
			 if (columnWidthArray.length != 0)
			 {
			 	documentToWrite.write("WIDTH='");
			 	documentToWrite.write(columnWidthArray[i]);
			 	documentToWrite.write("' ");
			 }
			 documentToWrite.write("><FONT SIZE='-1'>");

			if (columnHREFArray.length != 0)
			{
				documentToWrite.write("<A HREF=");
				documentToWrite.write(columnHREFArray[i]);
				documentToWrite.write(">");
			}

			 documentToWrite.write(columnHeaderArray[i]);
			 
			if (columnHREFArray.length != 0)
			{
				documentToWrite.write("<\A>");
			}
			 
			 documentToWrite.write("</font></TD>\n");
		 }
		documentToWrite.writeln("</TR>");

	return;
 }
 
  function AddLineToSortTable(documentToWrite, stringArray)
 {	
	documentToWrite.writeln("<TR>");

 	for (i = 0; i < stringArray.length; i++)
	{
		 documentToWrite.write("<TD><FONT SIZE='-1'>");
		 documentToWrite.write(stringArray[i]);
		 documentToWrite.write("</font></TD>\n");
	 }
	 documentToWrite.writeln("</TR>");
	return;
 }
 

 function EndSortTable(documentToWrite)
 {
 	documentToWrite.writeln("</TABLE>");
	 documentToWrite.writeln("</TD>");
	documentToWrite.writeln("</TR>");
	return;

 }



function DoSortColumn(sortArray, sortAsc, columnDataArray, columnCycleArray, compareFunction,  doRefresh)
{
	FillSortTable(sortArray, columnDataArray, columnCycleArray);	
	my_sort(sortArray, compareFunction);
	if (sortAsc == false) // sort descending
		sortArray[cycleIndex].reverse();
		
    SortTableAndRefresh(sortArray, columnCycleArray, doRefresh);
	return;

}



// end of sort stuff

 // -->
